
import * as $calcit from "./calcit.core.mjs";
import { _LT__GT_ } from "./respo.core.mjs";
import { create_element } from "./respo.core.mjs";
import { extract_effects_list } from "./respo.core.mjs";
import feather_icons from "feather-icons";
import { hsl } from "./respo.util.format.mjs";
import * as $respo_DOT_schema from "./respo.schema.mjs";
import { span } from "./respo.core.mjs";
var _kwd={};
["background-color","border-radius","color","comp-icon","display","effects","font-size","height","i","inline-block","innerHTML","line-height","name","on-click","padding","stle","style","tree","white","width",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function comp_icon(icon, style, on_click) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('comp-icon', 3, arguments.length);
return extract_effects_list($calcit._$n__PCT__$M_($respo_DOT_schema.Component, _kwd["effects"], $calcit._$L_(), _kwd["name"], _kwd["comp-icon"], _kwd["tree"], (function __fn__(){
(function __fn__(){
( $calcit.not($calcit.string_$q_("1: icon name in string")) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "1: icon name in string"));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ((function __fn__(){
let v1__1 = $calcit.string_$q_(icon);

if ($calcit.nil_$q_(v1__1)) { return $calcit.keyword_$q_(icon) }
 else if ($calcit._$e_(false, v1__1)) { return $calcit.keyword_$q_(icon) } else { return v1__1 }

})()) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("or"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("string?"), new $calcit.CalcitSymbol("icon")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("keyword?"), new $calcit.CalcitSymbol("icon")])]))));
let err_AUTO_2 = new Error("1: icon name in string (or (string? icon) (keyword? icon))");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();
(function __fn__(){
( $calcit.not($calcit.string_$q_("2: size in number")) ? (function __fn__(){
let err_AUTO_3 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "2: size in number"));
 err_AUTO_3.data = null;
 throw err_AUTO_3;
})() : null );

if ($calcit.number_$q_($calcit.get(style, _kwd["font-size"]))) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("number?"), new $calcit.CalcitSliceList([_kwd["font-size"], new $calcit.CalcitSymbol("style")])]))));
let err_AUTO_4 = new Error("2: size in number (number? (:font-size style))");
 err_AUTO_4.data = null;
 throw err_AUTO_4;
 }

})();
(function __fn__(){
( $calcit.not($calcit.string_$q_("3: color in string")) ? (function __fn__(){
let err_AUTO_5 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "3: color in string"));
 err_AUTO_5.data = null;
 throw err_AUTO_5;
})() : null );

if ($calcit.string_$q_($calcit.get(style, _kwd["color"]))) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("string?"), new $calcit.CalcitSliceList([_kwd["color"], new $calcit.CalcitSymbol("style")])]))));
let err_AUTO_6 = new Error("3: color in string (string? (:color style))");
 err_AUTO_6.data = null;
 throw err_AUTO_6;
 }

})();
let icon_name = $calcit.turn_string(icon);
let obj = $calcit.aget(feather_icons.icons, icon_name);

if ($calcit.some_$q_(obj)) { return create_element(_kwd["i"], $calcit._$n__$M_(_kwd["style"], $calcit.merge(style_base, style), _kwd["innerHTML"], ( $calcit.some_$q_(obj) ? obj.toSvg($calcit.to_js_data($calcit._$n__$M_(_kwd["width"], $calcit.get(style, _kwd["font-size"]), _kwd["height"], $calcit.get(style, _kwd["font-size"]), _kwd["color"], $calcit.get(style, _kwd["color"])))) : null ), _kwd["on-click"], on_click)) } else { console.error("No icon named:", $calcit.turn_string(icon));
return span($calcit._$n__$M_(_kwd["on-click"], on_click, _kwd["stle"], $calcit.merge(style_base, style, style_error)), _LT__GT_($calcit.str("No ", icon_name)))
 }


})()))
}



export var style_base = $calcit._$n__$M_(_kwd["display"], _kwd["inline-block"]);

export var style_error = $calcit._$n__$M_(_kwd["background-color"], hsl(0, 80, 70), _kwd["color"], _kwd["white"], _kwd["padding"], "0 8px", _kwd["line-height"], "24px", _kwd["border-radius"], "12px");

