
import * as $calcit from "./calcit.core.mjs";
var _kwd={};
["align-items","auto","background-color","border","border-radius","center","color","cursor","display","flex","flex-direction","flex-start","font-family","font-size","height","justify-content","left","line-height","min-width","none","outline","overflow","padding","position","row","text-align","top","transition-duration","user-select","vertical-align","white","width",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function hsl(h, s, l, a) { 
if (arguments.length < 3) throw new Error('too few arguments');
if (arguments.length > 4) throw new Error('too many arguments');

if ($calcit.some_$q_(a)) { return $calcit.str("hsl(", h, ",", s, "%,", l, "%,", a, ")") } else { return $calcit.str("hsl(", h, ",", s, "%,", l, "%)") }
}



export var button = $calcit._$n__$M_(_kwd["min-width"], "80px", _kwd["line-height"], "24px", _kwd["border-radius"], "4px", _kwd["font-size"], 14, _kwd["text-align"], "center", _kwd["border"], $calcit.str("1px solid ", hsl(220, 100, 76)), _kwd["color"], hsl(220, 100, 76), _kwd["cursor"], "pointer", _kwd["display"], "inline-block", _kwd["padding"], "0 8px", _kwd["outline"], _kwd["none"], _kwd["vertical-align"], _kwd["top"], _kwd["background-color"], _kwd["white"], _kwd["user-select"], _kwd["none"], _kwd["transition-duration"], "300ms");

export var center = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["flex-direction"], "column", _kwd["justify-content"], "center", _kwd["align-items"], "center");

export var column = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["align-items"], "stretch", _kwd["flex-direction"], "column");

export var column_dispersive = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["align-items"], "center", _kwd["justify-content"], "space-around", _kwd["flex-direction"], "column");

export var default_fonts = "Hind,Verdana,'Hiragino Sans GB','WenQuanYi Micro Hei','Microsoft Yahei',sans-serif";

export var flex = $calcit._$n__$M_(_kwd["flex"], 1);

export var font_code = "Source Code Pro, Menlo, Ubuntu Mono, Consolas, monospace";

export var font_fancy = "Josefin Sans, Helvetica neue, Arial, sans-serif";

export var font_normal = "Hind, Helvatica, Arial, sans-serif";

export var fullscreen = $calcit._$n__$M_(_kwd["position"], "absolute", _kwd["left"], 0, _kwd["top"], 0, _kwd["width"], "100%", _kwd["height"], "100%", _kwd["overflow"], _kwd["auto"]);

export var global = $calcit._$n__$M_(_kwd["line-height"], "2", _kwd["font-size"], "14px", _kwd["font-family"], default_fonts, _kwd["color"], hsl(0, 0, 20));

export var input = $calcit.merge(global, $calcit._$n__$M_(_kwd["border"], "none", _kwd["outline"], "none", _kwd["border"], $calcit.str("1px solid ", hsl(0, 0, 80)), _kwd["border-radius"], "4px", _kwd["font-size"], "14px", _kwd["padding"], "4px 8px", _kwd["min-width"], "120px", _kwd["line-height"], "16px", _kwd["height"], 28, _kwd["font-family"], default_fonts, _kwd["vertical-align"], _kwd["top"]));

export var row = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["align-items"], "stretch", _kwd["flex-direction"], "row");

export var row_center = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["align-items"], "center", _kwd["justify-content"], "center", _kwd["flex-direction"], "row");

export var row_middle = $calcit._$n__$M_(_kwd["display"], _kwd["flex"], _kwd["align-items"], _kwd["center"], _kwd["justify-content"], _kwd["flex-start"], _kwd["flex-direction"], _kwd["row"]);

export var row_parted = $calcit._$n__$M_(_kwd["display"], "flex", _kwd["align-items"], "center", _kwd["justify-content"], "space-between", _kwd["flex-direction"], "row");

